// Подключение библиотек.
// Библитоткa для датчика DHT11
#include "DHTesp.h"
// Библиотека для сервопривода
#include <Servo.h>
// Название WiFi
#define WIFI_SSID "TP-Link_DC2D"
// Пароль WiFi
#define WIFI_PASS "32384244"
// Токен бота телеграмм
#define BOT_TOKEN "5972201254:AAGq4plFuR9cblwtnOOwlWHlqhgH41e8Dqo"
//Библиотека для работы с ботом телеграмм
#include <FastBot.h>
// Передача токена бота
FastBot bot(BOT_TOKEN);

#ifdef ESP32
#pragma message(THIS EXAMPLE IS FOR ESP8266 ONLY!)
#error Select ESP8266 board.
#endif

Servo myservo;
DHTesp dht;
DHTesp dht2;
// ID аккаунта в Blynk
#define BLYNK_TEMPLATE_ID           "TMPLIrRHF2QA"
// Название микроконтролера
#define BLYNK_DEVICE_NAME           "Quickstart Device"
// Токен Blynk
#define BLYNK_AUTH_TOKEN            "iHFLU2aROuHgh9k0X0LM92MuMZSJdtQ9"
//Создаем константы для:
#define temp1 4 // Пина первого датчика температуры DHT11
#define vlaga A0 // Пина датчиков влажности почвы
#define temp2 0 // Пина второго датчика температуры DHT11
#define servo 5 // Пина сервопривода
#define nasos 13 // Пина реле для насоса
#define dsvet 2 // Пина для датчика освещённости
#define lenta 14 // Пина реле для светодиодной ленты
//Объявляем переменные для хранения:
float temp_1; // Температуры с первого датчика DHT11
float temp_2; // Температуры с второго датчика DHT11
int servo_1; // Положение ее нахождения
int nasos_1; // Состояние включено или выключено
float vlaga_0; // Значения с датчиков влажности почвы
int vlaga_1 = 99; // Влажности с первого датчика DHT11
int vlaga_2 = 88; //Влажности с второго датчика DHT11
int auto_rezim_okno = 1; //  Состояние включено или выключено
int auto_rezim_poliv = 0; //  Состояние включено или выключено
int auto_rezim_lenta = 1; //  Состояние включено или выключено
int sensor_pin = A0; // Аналоговый ПИН подключения датчика //
int data; // Влажности почвы

// Comment this out to disable prints and save space
#define BLYNK_PRINT Serial

// Подключаем библиотеку для esp
#include <ESP8266WiFi.h>
#include <BlynkSimpleEsp8266.h>

char auth[] = BLYNK_AUTH_TOKEN;

// Your WiFi credentials.
// для блинка
char ssid[] = "TP-Link_DC2D";
char pass[] = "32384244";
//Объявление виртуальных портов
BlynkTimer timer;

// This function is called every time the Virtual Pin 0 state changes
BLYNK_WRITE(V0)
{
  // Set incoming value from pin V0 to a variable
  int value = param.asInt();

  // Update state
  Blynk.virtualWrite(V1, value);
}

BLYNK_WRITE(V5) 
{
  Blynk.virtualWrite(V5, vlaga_1);
}

BLYNK_WRITE(V9)
{
  Blynk.virtualWrite(V9, temp_2);
}

BLYNK_WRITE(V4)
{
  Blynk.virtualWrite(V4, vlaga_0);
}

BLYNK_WRITE(V6)
{
  Blynk.virtualWrite(V6, temp_1);
}

BLYNK_WRITE(V7)
{
  Blynk.virtualWrite(V7, vlaga_2);
}

BLYNK_WRITE(V10)
{
  Blynk.virtualWrite(V10, nasos_1);
}

BLYNK_WRITE(V11)
{
  auto_rezim_poliv = param.asInt();
}

BLYNK_WRITE(V12)
{
  auto_rezim_okno = param.asInt();
}

BLYNK_WRITE(V13)
{
  Blynk.virtualWrite(V13, vlaga_2);
}

// Эта функция вызывается каждый раз, когда устройство подключается к Blynk.Облако
BLYNK_CONNECTED()
{
  // Change Web Link Button message to "Congratulations!"
  Blynk.setProperty(V3, "offImageUrl", "https://static-image.nyc3.cdn.digitaloceanspaces.com/general/fte/congratulations.png");
  Blynk.setProperty(V3, "onImageUrl",  "https://static-image.nyc3.cdn.digitaloceanspaces.com/general/fte/congratulations_pressed.png");
  Blynk.setProperty(V3, "url", "https://docs.blynk.io/en/getting-started/what-do-i-need-to-blynk/how-quickstart-device-was-made");
}
//Счет времени работы микроконтроллера
void myTimerEvent()
{

  Blynk.virtualWrite(V2, millis() / 1000);
}

void setup()
{
  // Ввод id чата
  bot.setChatID("5026574309");
  connectWiFi();
  // Подключение к чату
  bot.attach(newMsg);
  // Отправление сообщение при успешном подключении
  bot.sendMessage("Hello, World!");

  Blynk.begin(auth, ssid, pass);

  // Setup a function to be called every second
  timer.setInterval(1000L, myTimerEvent);
  // Задаем портам вход или выход
  pinMode(dsvet, INPUT);
  pinMode(lenta, OUTPUT);
  pinMode(nasos, OUTPUT);
  // Вывод тепмпературы в монитор порта
  Serial.begin(115200);
  Serial.println();
  Serial.println("Status\tHumidity (%)\tTemperature (C)\t(F)\tHeatIndex (C)\t(F)");
  // Hастройка первого датчика температуры и влажности
  dht.setup(temp1, DHTesp::DHT11);
  // Настройка сервопривода
  myservo.attach(servo);
  digitalWrite(nasos, OUTPUT);
  // Настройка второго датчика температуры и влажности
  dht2.setup(temp2, DHTesp::DHT11);
}
//Процедура обработки команд из телеграмм
void newMsg(FB_msg& msg) {
  // выводим ID чата, имя юзера и текст сообщения
  if (msg.text == "/hello") bot.sendMessage("Hello!", msg.chatID); // Если приходит сообщение /hello то отправляем ответное сообщение
  else if (msg.text == "/led_on") { // Если приходит сообщение /led_on, то фитолента включается
    digitalWrite(14, LOW);
    bot.sendMessage("Фитолента включена", msg.chatID);
  }
  else if (msg.text == "/led_off") { // Если приходит сообщение /led_off, то фитолента выключается
    digitalWrite(14, HIGH);
    bot.sendMessage("Фитолента выключена", msg.chatID);
  }
  else if (msg.text == "/watering_off") { // Если приходит сообщение /watering_off, то выключается полив
    digitalWrite(nasos, HIGH);
    bot.sendMessage("Полив выключен", msg.chatID);
    digitalWrite(nasos, HIGH);
  }
  else if (msg.text == "/watering_on") { // Если приходит сообщение /watering_on, то включается полив
    digitalWrite(nasos, LOW);
    bot.sendMessage("Полив включен", msg.chatID);
    digitalWrite(13, LOW);
  }
  else if (msg.text == "/auto_watering_on") { // Если приходит сообщение /auto_watering_on, то включается авто полив
    auto_rezim_poliv = 1;
    bot.sendMessage("Авто полив включен", msg.chatID);
    Blynk.virtualWrite(V11, HIGH);
  }
  else if (msg.text == "/auto_watering_off") {
    auto_rezim_poliv = 0;
    bot.sendMessage("Авто полив выключен", msg.chatID); // Если приходит сообщение /auto_watering_off, то авто полив выключается
    digitalWrite(nasos, HIGH);
    Blynk.virtualWrite(V11, LOW);
  }
  else if (msg.text == "/auto_led_off") { // Если приходит сообщение /auto_led_off, то авторежим фитоленты выключается
    auto_rezim_lenta = 0;
    bot.sendMessage("Авторежим Фитоленты выключен", msg.chatID);
  }
  else if (msg.text == "/auto_led_on") {  // Если приходит сообщение /auto_led_on, то авторежим фитоленты включается
    auto_rezim_lenta = 1;
    bot.sendMessage("Авторежим Фитоленты включен", msg.chatID);
  }
  else if (msg.text == "/klimat") { // Если приходит сообщение /klimat, то отправляется температуры и влажность воздуха внутри теплицы и снаружи
    bot.sendMessage("Температура внутри: " + String(temp_1) + "°C");
    bot.sendMessage("Влажность внутри: " + String(vlaga_1) + "%");
    bot.sendMessage("Температура снаружи: " + String(temp_2) + "°C");
    bot.sendMessage("Влажность снаружи: " + String(vlaga_2) + "%");
    bot.sendMessage("Влажность почвы: " + String(vlaga_0) + "%");

  }
  else if (msg.text == "/auto_airing_off") { // Если приходит сообщение /auto_airing_off, то авто проветривание выключается
    auto_rezim_okno = 0;
    bot.sendMessage("Авто проветривание выключено", msg.chatID);
    Blynk.virtualWrite(V12, LOW);
  }
  else if (msg.text == "/auto_airing_on") { // Если приходит сообщение /auto_airing_on, то авто проветривание включается
    auto_rezim_okno = 1;
    bot.sendMessage("Авто проветривание включено", msg.chatID);
    Blynk.virtualWrite(V12, HIGH);
  }


  else if (msg.text == "/window_lock") { // Если приходит сообщение /window_lock, то окно закрывается
    myservo.write(0);
    bot.sendMessage("Окно закрыто", msg.chatID);
  }
  else if (msg.text == "/window_position_1") { //Если приходит сообщение /window_position_1, то окно открывается на первое положение
    myservo.write(40);
    bot.sendMessage("Окно открыто на 1 положение", msg.chatID);
  }
  else if (msg.text == "/window_position_2") { //Если приходит сообщение /window_position_2, то окно открывается на второе положение
    myservo.write(80);
    bot.sendMessage("Окно открыто на 2 положение", msg.chatID);
  }
  else if (msg.text == "/window_position_3") { //Если приходит сообщение /window_position_3, то окно открывается на третье положение
    myservo.write(120);
    bot.sendMessage("Окно открыто на 3 положение", msg.chatID);
  }
  else if (msg.text == "/window_position_full") { //Если приходит сообщение /window_position_full, то окно открывается полностью
    myservo.write(160);
    bot.sendMessage("Окно открыто полностью", msg.chatID);
  }
  bot.sendMessage("Окно открыто полностью", msg.chatID);
   if (temp_1 >= 33) { 
       bot.sendMessage("Температура внутри теплицы опасна для жизни растений!!!", msg.chatID);
    }
    if (temp_2 >= 33) { 
       bot.sendMessage("Температура снаружи теплицы опасна для жизни растений!!!", msg.chatID);
    }
    if (vlaga_0 < 50) { 
       bot.sendMessage("Влажность почвы в теплице опасна для жизни растений!!!", msg.chatID);
    }
    if (vlaga_1 < 50) { 
       bot.sendMessage("Влажность воздуха внутри теплици опасна для жизни растений!!!", msg.chatID);
    }
    if (vlaga_2 < 50) { 
       bot.sendMessage("Влажность воздуха снаружи теплици опасна для жизни растений!!!", msg.chatID);
    }
}

void loop()
{
  // Функция для считывая сообщений
  bot.tick();
  // Запускаем Blynk
  Blynk.run();
  // Запускаем таймер работы микроконтролера
  timer.run();
  //Синхронизируем виртуальные  порты
  Blynk.syncVirtual(V2, V5, V4, V6, V7, V8, V9, V10, V11, V12, V13); // v3 темп внутри.v4влага v5влага.v6 наружняя темп.v7насос.v8серва
  // Задержка для первого датчика температуры и влажности воздуха
  delay(dht.getMinimumSamplingPeriod());
  vlaga_1 = dht.getHumidity();
  temp_1 = dht.getTemperature();
  //считываем значения выводим в монтиор порта
  Serial.print(dht.getStatusString());
  Serial.print("\t");
  Serial.print(vlaga_1, 1);
  Serial.print("\t\t");
  Serial.print(temp_1, 1);

  Serial.println();
  //Задержка для второго датчика температуры и влажности воздуха
  delay(dht2.getMinimumSamplingPeriod());
  vlaga_2 = dht2.getHumidity();
  temp_2 = dht2.getTemperature();

  Serial.print(dht2.getStatusString());
  Serial.print("\t");
  Serial.print(vlaga_2, 1);
  Serial.print("\t\t");
  Serial.print(temp_2, 1);
  //Автопроветривание
  Serial.println();
  if (auto_rezim_okno == 1)
  {
    if (temp_1 < 25) { // если температура меньше 25 то закрываем окно.
      myservo.write(0);
    }
    if (temp_1 >= 25 && temp_1  < 26) { // если температура больше или равна 25 ,но меньше 26, то открываем окно на первое положение.
      myservo.write(40);
    }
    if (temp_1 >= 26  && temp_1 < 27) { // если температура больше или равна 26 ,но меньше 37, то открываем окно на второе положение.
      myservo.write(80);
    }
    if (temp_1 >= 27 && temp_1 <  28) { // если температура больше или равна 27, но меньше 28, то открываем окно на третье положение.
      myservo.write(120);
    }
    if (temp_1 >= 29) { // если температура больше или равна 29 открываем окно полностью.
      myservo.write(160);
    }
  }
  data = analogRead(sensor_pin); // Считываем показания с датчика влажности поччвы
  Serial.print("не обработаная влажность: ");
  Serial.print(data); // Выводим показания
  Serial.println("");
  data = map(data, 675, 0, 100, 0); // переводим в проценты
  vlaga_0 = data;
  Serial.print("Влажность: ");
  Serial.print(data); // Выводим показания
  Serial.println("%");
  // Автополив
  if (auto_rezim_poliv == 1)
  {
    if (data > 75 ) { // если влажность меньше 75
      digitalWrite(nasos, HIGH); // То включаем полив
      nasos_1 = 1;
    } else { // Инчае
      digitalWrite(nasos, LOW); // Выключаем полив
      nasos_1 = 0;
    }
  }
  // Автоподсветка
  if   (auto_rezim_lenta == 1) { // Если датчик не видит свет
    if (digitalRead(dsvet)) {
      digitalWrite(lenta, HIGH); // Фитолента включается
    }
    else { //Иначе 
      digitalWrite(lenta, LOW); // Фитолента выключается 
    }
  }
}
//Процедура подключения к WiFi
void connectWiFi() {
  delay(2000);
  Serial.begin(115200);
  Serial.println();
  WiFi.begin(WIFI_SSID, WIFI_PASS);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
    if (millis() > 15000) ESP.restart();
  }
  Serial.println("Connected");
}